﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;


namespace _05_AddMeta
{
    class Program
    {
        static void Main(string[] args)
        {
            if (args.Length!=0)
            {
                foreach(string s in args)
                {
                    string text = "Copyright (c) 2017 Retro-Commodore.eu pdf creating help utility" + Environment.NewLine;
                    switch (s)
                    {
                        case "-help":
                            text += "-help Help text";
                            break;
                        case "-v":
                            text += "Version 0.01" + Environment.NewLine;
                            break;
                        case "-meta":
                            add_meta_to_pdfs();
                            break;
                        case "-extract":
                            extract_pages_from_pdfs();
                            break;
                        case "-g4compress":
                            g4compress();
                            break;
                        case "-makepdf":
                            make_pdfs_in_dirs();
                            break;
                        case "-createtorrent":
                            create_torrent();
                            break;
                        default:
                            break;
                    }
                    Console.WriteLine(text);
                }
            }

            extract_pages_from_pdfs();
            //g4compress();
           // make_pdfs_in_dirs();
           //add_meta_to_pdfs();
            // create_torrent();
            Console.WriteLine("Jobs done...");
            Console.ReadKey();
        }

        public static void add_meta_to_file(string filename, string outname)
        {
            ProcessStartInfo startInfo = new ProcessStartInfo()
            {
                FileName = "pdftk.exe",
                Arguments = "\"" + filename + "\"" + " update_info G:\\Retro-Work\\metadata.txt output " + "\"" + outname + "\"",
                UseShellExecute = false,
                CreateNoWindow = true,
                RedirectStandardError = true, 
                RedirectStandardOutput = true
            };
            Process p = new Process();
            //p.StartInfo.WindowStyle = ProcessWindowStyle.Hidden;
            p.StartInfo = startInfo;
            p.Start();
            //p.BeginOutputReadLine();
            string output = p.StandardOutput.ReadToEnd();
            Console.WriteLine(output);
            string err = p.StandardError.ReadToEnd();
            Console.WriteLine(err);

            p.WaitForExit();
        }

        public static void extract_images_from_pdf(string filename, string outdir)
        {
            string fArgument = "-q -dNOPAUSE -r600 -sDEVICE=tiff24nc -sCompression=lzw -sOutputFile=\"" + outdir + "\\_%04d.tif\" \"" + filename + "\" -c quit";
            ProcessStartInfo startInfo = new ProcessStartInfo()
            {
                FileName = "c:\\Program Files\\gs\\gs9.27\\bin\\gswin64c.exe",
                Arguments = fArgument,
                UseShellExecute = false,
                CreateNoWindow = true,
                RedirectStandardError = true,
                RedirectStandardOutput = true
            };
            Process p = new Process();
            //p.StartInfo.WindowStyle = ProcessWindowStyle.Hidden;
            p.StartInfo = startInfo;
            p.Start();
            //p.BeginOutputReadLine();
            string output = p.StandardOutput.ReadToEnd();
            Console.WriteLine(output);
            string err = p.StandardError.ReadToEnd();
            Console.WriteLine(err);

            p.WaitForExit();
        }

        static void add_meta_to_pdfs()
        {
            //var files = Directory.EnumerateFiles("C:\\path", "*.*", SearchOption.AllDirectories)
            // .Where(s => s.EndsWith(".mp3") || s.EndsWith(".jpg"));
            string[] files = Directory.GetFiles("G:\\Retro-Work\\Manual\\New folder\\", "*_recognized.pdf");

            Parallel.ForEach(files, (file) =>
                            {
                                string outFileName = Path.GetFileNameWithoutExtension(file.Replace("_recognized", ""));
                                string outdir = "G:\\Retro-Work\\Manual\\New folder\\ToTorrent\\";

                              //  if (!Directory.Exists(outdir + outFileName))
                               // {
                                //    DirectoryInfo di = Directory.CreateDirectory(outdir + outFileName);
                               // }

                                add_meta_to_file(file, outdir + outFileName + ".pdf");
                            });
        }


        static void extract_pages_from_pdfs()
        {
            string[] files = Directory.GetFiles(@"G:\Retro-Work\Manual\PDF-Extract\", "*.pdf");

            Parallel.ForEach(files, (file) =>
                            {
                                string outdir = @"G:\Retro-Work\Manual\PDF-Extract\";
                                string fileName = Path.GetFileNameWithoutExtension(file);

                                if (!Directory.Exists(outdir + fileName + "\\"))
                                {
                                    DirectoryInfo di = Directory.CreateDirectory(outdir + fileName);
                                }
                                extract_images_from_pdf(file, outdir + fileName);

                            });
        }

        static void g4compress()
        {
            string[] dirs = Directory.GetDirectories("G:\\Retro-Work\\Manual\\New folder\\work\\");

            foreach(string dir in dirs)
            {
                string outdir = dir + "\\g4out";

                if (!Directory.Exists(outdir))
                {
                    DirectoryInfo di = Directory.CreateDirectory(outdir);
                }
                g4compress_files(dir);

            }
        }

        static void g4compress_files(string dir)
        {

            string[] files = Directory.GetFiles(dir, "*.tif");

            Parallel.ForEach(files, (file) =>
                            {
                                string filename = Path.GetFileName(file);
                                string fArgument = "\"" + file + "\"" + " /tifc=4 /convert=\"" + dir + "\\g4out\\" + filename + "\"";
                                ProcessStartInfo startInfo = new ProcessStartInfo()
                                {
                                    FileName = "c:\\Program Files (x86)\\IrfanView\\i_view32.exe",
                                    Arguments = fArgument,
                                    UseShellExecute = false,
                                    CreateNoWindow = true,
                                    RedirectStandardError = true,
                                    RedirectStandardOutput = true
                                };
                                Process p = new Process();
                                //p.StartInfo.WindowStyle = ProcessWindowStyle.Hidden;
                                p.StartInfo = startInfo;
                                p.Start();
                                //p.BeginOutputReadLine();
                                string output = p.StandardOutput.ReadToEnd();
                                Console.WriteLine(output);
                                string err = p.StandardError.ReadToEnd();
                                Console.WriteLine(err);

                                p.WaitForExit();
                            });
        }


        static void make_pdfs_in_dirs()
        {
            string[] dirs = Directory.GetDirectories("G:\\Retro-Work\\Manual\\New folder\\work\\");

            foreach (string dir in dirs)
            {
                string outdir = dir + "\\pdf";

                if (!Directory.Exists(outdir))
                {
                    DirectoryInfo di = Directory.CreateDirectory(outdir);
                }
                make_pdf(dir);

            }
        }

        static void make_pdf(string dir)
        {

            string[] files = Directory.GetFiles(dir, "*.tif");

            Parallel.ForEach(files, (file) =>
            {
                string filename = Path.GetFileName(file);
                string fArgument = "\"" + file + "\" " + "\"" + dir + "\\pdf\\" + filename + ".pdf\"";
                ProcessStartInfo startInfo = new ProcessStartInfo()
                {
                    FileName = "C:\\Program Files\\ImageMagick-6.9.3-Q16\\convert.exe",
                    Arguments = fArgument,
                    UseShellExecute = false,
                    CreateNoWindow = true,
                    RedirectStandardError = true,
                    RedirectStandardOutput = true
                };
                Process p = new Process();
                p.StartInfo = startInfo;
                p.Start();
                string output = p.StandardOutput.ReadToEnd();
                Console.WriteLine(output);
                string err = p.StandardError.ReadToEnd();
                Console.WriteLine(err);

                p.WaitForExit();
            });


            string fileName = Path.GetFileName(dir);
            string fArgumentPDF = "\"" + dir + "\\pdf\\*.pdf\" G:\\Retro-Work\\brought_to_you_by_[TABLET].pdf cat output \"" + dir + "\\..\\" + fileName + ".pdf\"";
            ProcessStartInfo startInfo2 = new ProcessStartInfo()
            {
                FileName = "C:\\Program Files (x86)\\PDFtk Server\\bin\\pdftk.exe",
                Arguments = fArgumentPDF,
                UseShellExecute = false,
                CreateNoWindow = true,
                RedirectStandardError = true,
                RedirectStandardOutput = true
            };
            Process p2 = new Process();
            //p.StartInfo.WindowStyle = ProcessWindowStyle.Hidden;
            p2.StartInfo = startInfo2;
            p2.Start();
            //p.BeginOutputReadLine();
            string output2 = p2.StandardOutput.ReadToEnd();
            Console.WriteLine(output2);
            string err2 = p2.StandardError.ReadToEnd();
            Console.WriteLine(err2);

            p2.WaitForExit();
        }

        static void create_torrent(string dir = "G:\\Retro-Work\\Manual\\New folder\\ToTorrent")
        {
            string comment = "\"From the archives of http://retro-commodore.eu\"";
            string[] files = Directory.GetDirectories(dir);

            Parallel.ForEach(files, (file) =>
            {
                string fileName = Path.GetFileNameWithoutExtension(file);
                string fArgument = "-p -c " + comment + " -t udp://AmigaCity.xyz:6969 -o \"" + dir + "\\" + fileName + ".torrent\" \"" + file + "\"";
                ProcessStartInfo startInfo = new ProcessStartInfo()
                {
                    FileName = "C:\\Program Files\\Transmission\\transmission-create.exe",
                    Arguments = fArgument,
                    UseShellExecute = false,
                    CreateNoWindow = true,
                    RedirectStandardError = true,
                    RedirectStandardOutput = true
                };
                Process p = new Process();
                //p.StartInfo.WindowStyle = ProcessWindowStyle.Hidden;
                p.StartInfo = startInfo;
                p.Start();
                //p.BeginOutputReadLine();
                string output = p.StandardOutput.ReadToEnd();
                Console.WriteLine(output);
                string err = p.StandardError.ReadToEnd();
                Console.WriteLine(err);

                p.WaitForExit();

                File.AppendAllText(file + ".txt", Environment.NewLine + "torrent: " + fileName + ".torrent" + Environment.NewLine);

            });
        }

    }
}
